//*****************************************************************************
//*****************************************************************************
//  FILENAME:  INSAMP_1.h
//  Version: 2.0, Updated on 2003/08/28 at 17:09:28
//  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
//
//  DESCRIPTION: C declarations for a three-OpAmp Instrumentation Amplifier
//               topology in the 22/24/27/28xxx family of PSoC devices
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall INSAMP_1_Start
#pragma fastcall INSAMP_1_SetPower
#pragma fastcall INSAMP_1_Set2StageGain
#pragma fastcall INSAMP_1_Stop

//-------------------------------------------------
// Prototypes of the INSAMP_1 API.
//-------------------------------------------------
extern void INSAMP_1_Start(BYTE bPower);
extern void INSAMP_1_SetPower(BYTE bPower);
extern void INSAMP_1_Set2StageGain(BYTE bInGain, BYTE bOutGain);
extern void INSAMP_1_Stop(void);

//-------------------------------------------------
// Defines for INSAMP_1 API's.
//-------------------------------------------------
#define INSAMP_1_OFF         0
#define INSAMP_1_LOWPOWER    1
#define INSAMP_1_MEDPOWER    2
#define INSAMP_1_HIGHPOWER   3

#define INSAMP_1_INGAIN_48     (0x01)
#define INSAMP_1_INGAIN_24     (0x11)
#define INSAMP_1_INGAIN_16     (0x00)
#define INSAMP_1_INGAIN_8      (0x10)
#define INSAMP_1_INGAIN_5_33   (0x20)
#define INSAMP_1_INGAIN_4      (0x30)
#define INSAMP_1_INGAIN_3_20   (0x40)
#define INSAMP_1_INGAIN_2_67   (0x50)
#define INSAMP_1_INGAIN_2_29   (0x60)
#define INSAMP_1_INGAIN_2      (0x70)
#define INSAMP_1_INGAIN_1_78   (0x80)
#define INSAMP_1_INGAIN_1_60   (0x90)
#define INSAMP_1_INGAIN_1_45   (0xA0)
#define INSAMP_1_INGAIN_1_33   (0xB0)
#define INSAMP_1_INGAIN_1_23   (0xC0)
#define INSAMP_1_INGAIN_1_14   (0xD0)
#define INSAMP_1_INGAIN_1_07   (0xE0)
#define INSAMP_1_INGAIN_1      (0xF0)

#define INSAMP_1_OUTGAIN_0_03  (0x81)
#define INSAMP_1_OUTGAIN_0_06  (0x82)
#define INSAMP_1_OUTGAIN_0_09  (0x83)
#define INSAMP_1_OUTGAIN_0_13  (0x84)
#define INSAMP_1_OUTGAIN_0_16  (0x85)
#define INSAMP_1_OUTGAIN_0_19  (0x86)
#define INSAMP_1_OUTGAIN_0_22  (0x87)
#define INSAMP_1_OUTGAIN_0_25  (0x88)
#define INSAMP_1_OUTGAIN_0_28  (0x89)
#define INSAMP_1_OUTGAIN_0_31  (0x8A)
#define INSAMP_1_OUTGAIN_0_34  (0x8B)
#define INSAMP_1_OUTGAIN_0_38  (0x8C)
#define INSAMP_1_OUTGAIN_0_41  (0x8D)
#define INSAMP_1_OUTGAIN_0_44  (0x8E)
#define INSAMP_1_OUTGAIN_0_47  (0x8F)
#define INSAMP_1_OUTGAIN_0_50  (0x90)
#define INSAMP_1_OUTGAIN_0_53  (0x91)
#define INSAMP_1_OUTGAIN_0_56  (0x92)
#define INSAMP_1_OUTGAIN_0_59  (0x93)
#define INSAMP_1_OUTGAIN_0_63  (0x94)
#define INSAMP_1_OUTGAIN_0_66  (0x95)
#define INSAMP_1_OUTGAIN_0_69  (0x96)
#define INSAMP_1_OUTGAIN_0_72  (0x97)
#define INSAMP_1_OUTGAIN_0_75  (0x98)
#define INSAMP_1_OUTGAIN_0_78  (0x99)
#define INSAMP_1_OUTGAIN_0_81  (0x9A)
#define INSAMP_1_OUTGAIN_0_84  (0x9B)
#define INSAMP_1_OUTGAIN_0_88  (0x9C)
#define INSAMP_1_OUTGAIN_0_91  (0x9D)
#define INSAMP_1_OUTGAIN_0_94  (0x9E)
#define INSAMP_1_OUTGAIN_0_97  (0x9F)
#define INSAMP_1_OUTGAIN_1_00  (0x10)
#define INSAMP_1_OUTGAIN_1_06  (0x11)
#define INSAMP_1_OUTGAIN_1_13  (0x12)
#define INSAMP_1_OUTGAIN_1_19  (0x13)
#define INSAMP_1_OUTGAIN_1_25  (0x14)
#define INSAMP_1_OUTGAIN_1_31  (0x15)
#define INSAMP_1_OUTGAIN_1_38  (0x16)
#define INSAMP_1_OUTGAIN_1_44  (0x17)
#define INSAMP_1_OUTGAIN_1_50  (0x18)
#define INSAMP_1_OUTGAIN_1_56  (0x19)
#define INSAMP_1_OUTGAIN_1_63  (0x1A)
#define INSAMP_1_OUTGAIN_1_69  (0x1B)
#define INSAMP_1_OUTGAIN_1_75  (0x1C)
#define INSAMP_1_OUTGAIN_1_81  (0x1D)
#define INSAMP_1_OUTGAIN_1_88  (0x1E)
#define INSAMP_1_OUTGAIN_1_94  (0x1F)


//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

#pragma ioport  INSAMP_1_INV_CR0:   0x079
BYTE            INSAMP_1_INV_CR0;
#pragma ioport  INSAMP_1_INV_CR1:   0x07a
BYTE            INSAMP_1_INV_CR1;
#pragma ioport  INSAMP_1_INV_CR2:   0x07b
BYTE            INSAMP_1_INV_CR2;
#pragma ioport  INSAMP_1_INV_CR3:   0x078
BYTE            INSAMP_1_INV_CR3;

#pragma ioport  INSAMP_1_NON_INV_CR0:   0x07d
BYTE            INSAMP_1_NON_INV_CR0;
#pragma ioport  INSAMP_1_NON_INV_CR1:   0x07e
BYTE            INSAMP_1_NON_INV_CR1;
#pragma ioport  INSAMP_1_NON_INV_CR2:   0x07f
BYTE            INSAMP_1_NON_INV_CR2;
#pragma ioport  INSAMP_1_NON_INV_CR3:   0x07c
BYTE            INSAMP_1_NON_INV_CR3;

#pragma ioport  INSAMP_1_CONVERT_CR0:   0x088
BYTE            INSAMP_1_CONVERT_CR0;
#pragma ioport  INSAMP_1_CONVERT_CR1:   0x089
BYTE            INSAMP_1_CONVERT_CR1;
#pragma ioport  INSAMP_1_CONVERT_CR2:   0x08a
BYTE            INSAMP_1_CONVERT_CR2;
#pragma ioport  INSAMP_1_CONVERT_CR3:   0x08b
BYTE            INSAMP_1_CONVERT_CR3;


// end of file INSAMP_1.h
