;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   INSAMP_1.inc
;;  Version: 2.0, Updated on 2003/08/28 at 17:09:28
;;  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
;;
;;  DESCRIPTION:
;;    Assembler declarations for a three-OpAmp Instrumentation Amplifier
;;    topology in the 22/24/27/28xxx family of PSoC devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"

;--------------------------------------------------
; Constants for INSAMP_1 API's.
;--------------------------------------------------

INSAMP_1_OFF:                      equ 0
INSAMP_1_LOWPOWER:                 equ 1
INSAMP_1_MEDPOWER:                 equ 2
INSAMP_1_HIGHPOWER:                equ 3

INSAMP_1_INGAIN_48:                equ 0x01
INSAMP_1_INGAIN_24:                equ 0x11
INSAMP_1_INGAIN_16:                equ 0x00
INSAMP_1_INGAIN_8:                 equ 0x10
INSAMP_1_INGAIN_5_33:              equ 0x20
INSAMP_1_INGAIN_4:                 equ 0x30
INSAMP_1_INGAIN_3_20:              equ 0x40
INSAMP_1_INGAIN_2_67:              equ 0x50
INSAMP_1_INGAIN_2_29:              equ 0x60
INSAMP_1_INGAIN_2:                 equ 0x70
INSAMP_1_INGAIN_1_78:              equ 0x80
INSAMP_1_INGAIN_1_60:              equ 0x90
INSAMP_1_INGAIN_1_45:              equ 0xA0
INSAMP_1_INGAIN_1_33:              equ 0xB0
INSAMP_1_INGAIN_1_23:              equ 0xC0
INSAMP_1_INGAIN_1_14:              equ 0xD0
INSAMP_1_INGAIN_1_07:              equ 0xE0
INSAMP_1_INGAIN_1:                 equ 0xF0

INSAMP_1_OUTGAIN_0_03:             equ 0x81
INSAMP_1_OUTGAIN_0_06:             equ 0x82
INSAMP_1_OUTGAIN_0_09:             equ 0x83
INSAMP_1_OUTGAIN_0_13:             equ 0x84
INSAMP_1_OUTGAIN_0_16:             equ 0x85
INSAMP_1_OUTGAIN_0_19:             equ 0x86
INSAMP_1_OUTGAIN_0_22:             equ 0x87
INSAMP_1_OUTGAIN_0_25:             equ 0x88
INSAMP_1_OUTGAIN_0_28:             equ 0x89
INSAMP_1_OUTGAIN_0_31:             equ 0x8A
INSAMP_1_OUTGAIN_0_34:             equ 0x8B
INSAMP_1_OUTGAIN_0_38:             equ 0x8C
INSAMP_1_OUTGAIN_0_41:             equ 0x8D
INSAMP_1_OUTGAIN_0_44:             equ 0x8E
INSAMP_1_OUTGAIN_0_47:             equ 0x8F
INSAMP_1_OUTGAIN_0_50:             equ 0x90
INSAMP_1_OUTGAIN_0_53:             equ 0x91
INSAMP_1_OUTGAIN_0_56:             equ 0x92
INSAMP_1_OUTGAIN_0_59:             equ 0x93
INSAMP_1_OUTGAIN_0_63:             equ 0x94
INSAMP_1_OUTGAIN_0_66:             equ 0x95
INSAMP_1_OUTGAIN_0_69:             equ 0x96
INSAMP_1_OUTGAIN_0_72:             equ 0x97
INSAMP_1_OUTGAIN_0_75:             equ 0x98
INSAMP_1_OUTGAIN_0_78:             equ 0x99
INSAMP_1_OUTGAIN_0_81:             equ 0x9A
INSAMP_1_OUTGAIN_0_84:             equ 0x9B
INSAMP_1_OUTGAIN_0_88:             equ 0x9C
INSAMP_1_OUTGAIN_0_91:             equ 0x9D
INSAMP_1_OUTGAIN_0_94:             equ 0x9E
INSAMP_1_OUTGAIN_0_97:             equ 0x9F
INSAMP_1_OUTGAIN_1_00:             equ 0x10
INSAMP_1_OUTGAIN_1_06:             equ 0x11
INSAMP_1_OUTGAIN_1_13:             equ 0x12
INSAMP_1_OUTGAIN_1_19:             equ 0x13
INSAMP_1_OUTGAIN_1_25:             equ 0x14
INSAMP_1_OUTGAIN_1_31:             equ 0x15
INSAMP_1_OUTGAIN_1_38:             equ 0x16
INSAMP_1_OUTGAIN_1_44:             equ 0x17
INSAMP_1_OUTGAIN_1_50:             equ 0x18
INSAMP_1_OUTGAIN_1_56:             equ 0x19
INSAMP_1_OUTGAIN_1_63:             equ 0x1A
INSAMP_1_OUTGAIN_1_69:             equ 0x1B
INSAMP_1_OUTGAIN_1_75:             equ 0x1C
INSAMP_1_OUTGAIN_1_81:             equ 0x1D
INSAMP_1_OUTGAIN_1_88:             equ 0x1E
INSAMP_1_OUTGAIN_1_94:             equ 0x1F

;--------------------------------------------------
; Register Address Constants for INSAMP_1
;--------------------------------------------------

INSAMP_1_INV_CR0:                  equ 0x79  ; CT Block Control Register 0
INSAMP_1_INV_CR1:                  equ 0x7a  ; CT Block Control Register 1
INSAMP_1_INV_CR2:                  equ 0x7b  ; CT Block Control Register 2
INSAMP_1_INV_CR3:                  equ 0x78  ; CT Block Control Register 3

INSAMP_1_NON_INV_CR0:              equ 0x7d  ; CT Block Control Register 0
INSAMP_1_NON_INV_CR1:              equ 0x7e  ; CT Block Control Register 1
INSAMP_1_NON_INV_CR2:              equ 0x7f  ; CT Block Control Register 2
INSAMP_1_NON_INV_CR3:              equ 0x7c  ; CT Block Control Register 3

INSAMP_1_CONVERT_CR0:              equ 0x88  ; SC Block Control Register 0
INSAMP_1_CONVERT_CR1:              equ 0x89  ; SC Block Control Register 1
INSAMP_1_CONVERT_CR2:              equ 0x8a  ; SC Block Control Register 2
INSAMP_1_CONVERT_CR3:              equ 0x8b  ; SC Block Control Register 3


; end of file INSAMP_1.inc
