;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   ADCINC12_U.inc
;;  Version: 5.0, Updated on 2003/08/28 at 13:26:44
;;  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
;;
;;  DESCRIPTION:
;;    Assembler declarations for the ACDINC12 user module interface
;;    for the 22/24/27xxx PSoC family of devices.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************


;--------------------------------------------------
; Constants for ADCINC12_U API's
;--------------------------------------------------
ADCINC12_U_TimerMask:                  equ  01h
ADCINC12_U_CounterMask:                equ  02h
ADCINC12_U_OFF:                        equ  0
ADCINC12_U_LOWPOWER:                   equ  1
ADCINC12_U_MEDPOWER:                   equ  2
ADCINC12_U_HIGHPOWER:                  equ  3
ADCINC12_U_NUMBITS:                    equ  12
ADCINC12_U_NoAZ:                       equ  1
ADCINC12_U_CNTINPUT:                   equ  ((0 + 4)<<4)
ADCINC12_U_fDBLK_ENABLE:               equ  01h      ; Digital block enable bit     
ADCINC12_U_fPULSE_WIDE:                equ  04h      ; Set to wide terminal count pulse 
HighByte:                     equ  0
LowByte:                      equ  1

;--------------------------------------------------
; Registers Address Constants for ADCINC12_U
;--------------------------------------------------

ADCINC12_U_AtoDcr0: equ 80h
ADCINC12_U_AtoDcr1: equ 81h
ADCINC12_U_AtoDcr2: equ 82h
ADCINC12_U_AtoDcr3: equ 83h
ADCINC12_U_CounterFN:   equ 24h
ADCINC12_U_CounterSL:   equ 25h
ADCINC12_U_CounterOS:   equ 26h
ADCINC12_U_CounterDR0:  equ 24h
ADCINC12_U_CounterDR1:  equ 25h
ADCINC12_U_CounterDR2:  equ 26h
ADCINC12_U_CounterCR0:  equ 27h
ADCINC12_U_TimerFN: equ 20h
ADCINC12_U_TimerSL: equ 21h
ADCINC12_U_TimerOS: equ 22h
ADCINC12_U_TimerDR0:    equ 20h
ADCINC12_U_TimerDR1:    equ 21h
ADCINC12_U_TimerDR2:    equ 22h
ADCINC12_U_TimerCR0:    equ 23h

;--------------------------------------------------
; ADCINC12_U Macro 'Functions'
;--------------------------------------------------

macro ADCINC12_U_ISDATA
   mov A,[ADCINC12_U_fIncr]
   endm

macro ADCINC12_U_GETDATA
   mov X,[(ADCINC12_U_iIncr + HighByte)]
   mov A,[(ADCINC12_U_iIncr + LowByte)]
   endm

macro ADCINC12_U_CLEARFLAG
   mov [ADCINC12_U_fIncr],00h
   endm

; End of file ADCINC12_U.inc



