;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DAC8_REF.inc
;;   Version: 1.2, Updated on 2003/08/28 at 17:07:35
;;  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
;;
;;  DESCRIPTION:  Assembler declarations for the DAC8 user module interface
;;                for the 22/24/25/26/27xxx PSoC family of devices.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2001-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

;--------------------------------------------------
; Constants for DAC8_REF API's
;--------------------------------------------------

DAC8_REF_OFF:              equ 00h
DAC8_REF_LOWPOWER:         equ 01h
DAC8_REF_MEDPOWER:         equ 02h
DAC8_REF_HIGHPOWER:        equ 03h

DAC8_REF_LSB_CR0:          equ 90h
DAC8_REF_LSB_CR1:          equ 91h
DAC8_REF_LSB_CR2:          equ 92h
DAC8_REF_LSB_CR3:          equ 93h
DAC8_REF_MSB_CR0:          equ 94h
DAC8_REF_MSB_CR1:          equ 95h
DAC8_REF_MSB_CR2:          equ 96h
DAC8_REF_MSB_CR3:          equ 97h

DAC8_REF_OffsetBinary:     equ 04h
DAC8_REF_TwosComplement:   equ 02h
DAC8_REF_SignAndMagnitude: equ 01h
DAC8_REF_RawRegister:      equ 00h

DAC8_REF_DATAFORMAT:       equ 7h
DAC8_REF_OFFSETBINARY:     equ DAC8_REF_DATAFORMAT & DAC8_REF_OffsetBinary
DAC8_REF_TWOSCOMPLEMENT:   equ DAC8_REF_DATAFORMAT & DAC8_REF_TwosComplement
DAC8_REF_SIGNANDMAGNITUDE: equ DAC8_REF_DATAFORMAT & DAC8_REF_SignAndMagnitude

DAC8_REF_PHASE_Normal:     equ 0
DAC8_REF_PHASE_Swapped:    equ 1

DAC8_REF_PHASE_SWAP:       equ DAC8_REF_PHASE_Normal

IF DAC8_REF_PHASE_SWAP
    DAC8_REF_CR0_HIBITS:   equ C0h
ELSE
    DAC8_REF_CR0_HIBITS:   equ 80h
ENDIF

;--------------------------------------------------
; Register Address Constants for DAC8_REF
;--------------------------------------------------
DAC8_REF_LSB_CR0:   equ 90h                      ; LSB SC Block Control Register 0
DAC8_REF_LSB_CR1:   equ 91h                      ; LSB SC Block Control Register 1
DAC8_REF_LSB_CR2:   equ 92h                      ; LSB SC Block Control Register 2
DAC8_REF_LSB_CR3:   equ 93h                      ; LSB SC Block Control Register 3

DAC8_REF_MSB_CR0:   equ 94h                      ; MSB SC Block Control Register 0
DAC8_REF_MSB_CR1:   equ 95h                      ; MSB SC Block Control Register 1
DAC8_REF_MSB_CR2:   equ 96h                      ; MSB SC Block Control Register 2
DAC8_REF_MSB_CR3:   equ 97h                      ; MSB SC Block Control Register 3

; end of file DAC8_REF.inc
