	.module main.c
	.area data(ram, con, rel)
_cpt::
	.blkb 4
	.area idata
	.word 0,0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e cpt _cpt L
_cpts::
	.blkb 4
	.area idata
	.word 0,0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e cpts _cpts L
_Uref::
	.blkb 4
	.area idata
	.word 0,2200
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e Uref _Uref L
_Ubas::
	.blkb 4
	.area idata
	.word 0,2000
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e Ubas _Ubas L
_Eref::
	.blkb 4
	.area idata
	.word 1525,57600
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e Eref _Eref L
_k::
	.blkb 4
	.area idata
	.word 0,4
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e k _k L
_f::
	.blkb 4
	.area idata
	.word 0,300
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e f _f L
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e Acquis _Acquis fV
_Acquis::
	.dbline -1
	.dbline 52
; /****************************************************************************/
; /****************************************************************************/
; /**																		   **/
; /**					   Calcul de l'nergie sur une batterie				   **/
; /**																		   **/
; /****************************************************************************/
; /****************************************************************************/
; /**																		   **/
; /**						        Julien VILLEMEJANE						   **/
; /**																		   **/
; /****************************************************************************/
; /****************************************************************************/
; /**  	                   ENS Cachan - Dpartement EEA					   **/
; /****************************************************************************/
; /****************************************************************************/
; 
; 
; 		// Port 0 - Bit 5 --> Sortie analogique Vref=2,5V
;  
; 	    // Port 1 - Bit 0 --> Signal rechargement
;     	// Port 1 - Bit 1 --> Signal batterie dcharge
;     	// Port 1 - Bit 2 --< Entre de rinitialisation
;     	// Port 1 - Bit 3 --> Signal allum/teint
; 		// Port 1 - Bit 4 --< Entre de rinitialisation (test)
; 
;     	// Port 2 - Bit 1 --< Entre analogique U
;     	// Port 2 - Bit 2 --< Entre analogique I
; 
; 
; #include "m8c.h"       			// part specific constants and macros
; #include "PSoCAPI.h"    		// PSoC API definitions for all User Modules
; 
; // Dclaration des variables
; /* Variables "variables" */
; long U,I,Ucalc;
; long E,Ep;							// Energie discrte
; long En;							// Energie "instantane" discrte
; char Es[4];							// Energie convertie en char	
; long cpt=0,cpts=0;					// compteur pour l'initialisation et la sauvegarde
; 
; /* Variables "fixes" */
; long Uref=2200;						// tension de rfrence (correspond  10,3 V environ)
; long Ubas=2000;						// valeur critique de dcharge de la batterie (environ U=9V)
; long Eref=100000000;				// permet de tenir 4-5 min aprs l'envoi du signal de rechargement
; long k=4;							// coefficient multiplicateur pour le calcul de E
; long f=300;							// frequence pour le calcul de E : E = U.I/(k*f)
; 
; 
; /************************************/
; /* Fonction d'acquisition de U et I */
; /************************************/
; void Acquis(){
	.dbline 53
; 	ADCINC12_U_GetSamples(1);
	push X
	mov A,1
	xcall _ADCINC12_U_GetSamples
	.dbline 54
; 	ADCINC12_I_GetSamples(1);
	mov A,1
	xcall _ADCINC12_I_GetSamples
	pop X
L2:
	.dbline 56
L3:
	.dbline 56
; 	
; 	while(ADCINC12_U_fIsDataAvailable() == 0);		// Attente de rcupration de U
	push X
	xcall _ADCINC12_U_fIsDataAvailable
	pop X
	cmp A,0
	jz L2
	.dbline 57
; 	U=(ADCINC12_U_iGetData()+2048);					// Rcupration de U
	push X
	xcall _ADCINC12_U_iGetData
	mov [__r1],A
	mov [__r0],X
	pop X
	add [__r1],0
	adc [__r0],8
	mov [_U+3],[__r1]
	mov [_U+2],[__r0]
	tst [_U+2],-128
	jz X0
	mov [_U+1],-1
	mov [_U],-1
	jmp X1
X0:
	mov [_U+1],0
	mov [_U],0
X1:
	.dbline 58
; 	ADCINC12_U_ClearFlag();
	push X
	xcall _ADCINC12_U_ClearFlag
	pop X
L5:
	.dbline 60
L6:
	.dbline 60
; 
; 	while(ADCINC12_I_fIsDataAvailable() == 0);		// Attente de rcupration de I
	push X
	xcall _ADCINC12_I_fIsDataAvailable
	pop X
	cmp A,0
	jz L5
	.dbline 61
; 	I=2*ADCINC12_I_iGetData();						// Rcupration de I
	push X
	xcall _ADCINC12_I_iGetData
	mov [__r1],A
	mov [__r0],X
	pop X
	asl [__r1]
	rlc [__r0]
	mov [_I+3],[__r1]
	mov [_I+2],[__r0]
	tst [_I+2],-128
	jz X2
	mov [_I+1],-1
	mov [_I],-1
	jmp X3
X2:
	mov [_I+1],0
	mov [_I],0
X3:
	.dbline 62
; 	ADCINC12_I_ClearFlag();
	push X
	xcall _ADCINC12_I_ClearFlag
	pop X
	.dbline 64
; 	
; 	Ucalc=U/16;										// Test du signal
	mov A,0
	push A
	push A
	push A
	mov A,16
	push A
	mov A,[_U]
	push A
	mov A,[_U+1]
	push A
	mov A,[_U+2]
	push A
	mov A,[_U+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [_Ucalc+3],A
	pop A
	mov [_Ucalc+2],A
	pop A
	mov [_Ucalc+1],A
	pop A
	mov [_Ucalc],A
	add SP,-4
	.dbline 65
; 	DAC8_REF_WriteBlind(Ucalc);						// Signal de rfrence pour le courant
	mov [__r0],[_Ucalc+3]
	push X
	mov A,[__r0]
	xcall _DAC8_REF_WriteBlind
	pop X
	.dbline -2
	.dbline 67
; 	
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e saveE _saveE fV
_saveE::
	.dbline -1
	.dbline 77
; 
; 
; /************************************/
; /* Fonction de translation E --> Es */
; /*  		long  -> char			*/
; /*									*/
; /* 		Sauvegarde des donnes 		*/
; /*	  toutes les 30 sec en Flash	*/
; /************************************/
; void saveE(){
	.dbline 78
; 	if(cpts>9000){							// procedure de memorisation toute les 30s environ
	mov A,[_cpts]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_cpts+3]
	sub A,40
	or [__rX],A
	mov A,[_cpts+2]
	sbb A,35
	or [__rX],A
	mov A,[_cpts+1]
	sbb A,0
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L9
	mov A,[__rX]
	jz L9
X4:
	.dbline 78
	.dbline 80
; 		// MSB
; 		Ep = E & 0xFF000000;				// Application d'un masque sur les bits de poids fort
	mov A,[_E+3]
	and A,0
	mov [__r3],A
	mov A,[_E+2]
	and A,0
	mov [__r2],A
	mov A,[_E+1]
	and A,0
	mov [__r1],A
	mov A,[_E]
	and A,-1
	mov [_Ep],A
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 81
; 		Ep=Ep>>24;							// Decalage a droite de 24 bits
	mov [__r0],[_Ep]
	mov [__r1],[_Ep+1]
	mov [__r2],[_Ep+2]
	mov [__r3],[_Ep+3]
	mov A,24
X5:
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X5
	mov [_Ep],[__r0]
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 82
; 		Es[0]=(unsigned char)Ep;			// Memorisation
	mov [__r1],[_Ep+3]
	mov [_Es],[__r1]
	.dbline 84
; 		// 3e octet
; 		Ep = E & 0x00FF0000;				// Application d'un masque sur les 8 bits suivants
	mov A,[_E+3]
	and A,0
	mov [_Ep+3],A
	mov A,[_E+2]
	and A,0
	mov [_Ep+2],A
	mov A,[_E+1]
	and A,-1
	mov [_Ep+1],A
	mov A,[_E]
	and A,0
	mov [_Ep],A
	.dbline 85
; 		Ep=Ep>>16;							// Decalage a droite de 16 bits
	mov [__r0],[_Ep]
	mov [__r1],[_Ep+1]
	mov [__r2],[_Ep+2]
	mov [__r3],[_Ep+3]
	mov A,16
X6:
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X6
	mov [_Ep],[__r0]
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 86
; 		Es[1]=(unsigned char)Ep;			// Memorisation
	mov [__r1],[_Ep+3]
	mov [_Es+1],[__r1]
	.dbline 88
; 		// 2e octet
; 		Ep = E & 0x0000FF00;				// Application d'un masque sur les 8 bits suivants
	mov A,[_E+3]
	and A,0
	mov [_Ep+3],A
	mov A,[_E+2]
	and A,-1
	mov [_Ep+2],A
	mov A,[_E+1]
	and A,0
	mov [_Ep+1],A
	mov A,[_E]
	and A,0
	mov [_Ep],A
	.dbline 89
; 		Ep=Ep>>8;							// Decalage a droite de 8 bits
	mov [__r0],[_Ep]
	mov [__r1],[_Ep+1]
	mov [__r2],[_Ep+2]
	mov [__r3],[_Ep+3]
	mov A,8
X7:
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X7
	mov [_Ep],[__r0]
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 90
; 		Es[2]=(unsigned char)Ep;			// Memorisation
	mov [__r1],[_Ep+3]
	mov [_Es+2],[__r1]
	.dbline 92
; 		// LSB	
; 		Ep = E & 0x000000FF;				// Application d'un masque sur les bits de poids faible
	mov A,[_E+3]
	and A,-1
	mov [_Ep+3],A
	mov A,[_E+2]
	and A,0
	mov [_Ep+2],A
	mov A,[_E+1]
	and A,0
	mov [_Ep+1],A
	mov A,[_E]
	and A,0
	mov [_Ep],A
	.dbline 93
; 		Es[3]=(unsigned char)Ep;			// Memorisation
	mov [__r1],[_Ep+3]
	mov [_Es+3],[__r1]
	.dbline 95
; 		// Ecriture en Flash
; 		E2PROM_E_bE2Write(0,Es,4,25);
	push X
	mov A,25
	push A
	mov A,0
	push A
	mov A,4
	push A
	mov A,>_Es
	push A
	mov A,<_Es
	push A
	mov A,0
	push A
	push A
	mov X,SP
	dec X
	xcall _E2PROM_E_bE2Write
	add SP,-7
	pop X
	.dbline 96
; 		cpts=0;
	mov [_cpts],0
	mov [_cpts+1],0
	mov [_cpts+2],0
	mov [_cpts+3],0
	.dbline 97
; 	}
	xjmp L10
L9:
	.dbline 98
	.dbline 98
	add [_cpts+3],1
	adc [_cpts+2],0
	adc [_cpts+1],0
	adc [_cpts],0
	.dbline 98
L10:
	.dbline -2
	.dbline 99
; 	else{cpts++;}
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e readE _readE fV
_readE::
	.dbline -1
	.dbline 106
; 
; 
; /************************************/
; /* Fonction de translation Es --> E */
; /*  		char  -> long			*/
; /************************************/
; void readE(){
	.dbline 108
; 	// Lecture sur Flash
; 	E2PROM_E_E2Read(0,Es,4);
	push X
	mov A,0
	push A
	mov A,4
	push A
	mov A,>_Es
	push A
	mov A,<_Es
	push A
	mov A,0
	push A
	push A
	mov X,SP
	dec X
	xcall _E2PROM_E_E2Read
	add SP,-6
	pop X
	.dbline 110
; 	//MSB
; 	Ep=(unsigned long)Es[0];				// Acquisition des 8 premiers bits memoriss
	mov [__r3],[_Es]
	mov [_Ep],0
	mov [_Ep+1],0
	mov [_Ep+2],0
	mov [_Ep+3],[__r3]
	.dbline 111
; 	Ep=Ep<<8;								// Decalage a gauche de 8 bits
	mov [__r0],[_Ep]
	mov [__r1],[_Ep+1]
	mov [__r2],[_Ep+2]
	mov [__r3],[_Ep+3]
	mov A,8
X8:
	asl [__r3]
	rlc [__r2]
	rlc [__r1]
	rlc [__r0]
	dec A
	jnz X8
	mov [_Ep],[__r0]
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 113
; 	// 3e octet
; 	Ep+=(unsigned long)Es[1];				// Acquisition des 8 bits suivants
	mov [__r3],[_Es+1]
	mov [__r2],0
	mov [__r1],0
	mov [__r0],0
	mov A,[_Ep+3]
	add A,[__r3]
	mov [__r3],A
	mov A,[_Ep+2]
	adc A,[__r2]
	mov [__r2],A
	mov A,[_Ep+1]
	adc A,[__r1]
	mov [__r1],A
	mov A,[_Ep]
	adc A,[__r0]
	mov [_Ep],A
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 114
; 	Ep=Ep<<8;								// Decalage a gauche de 8 bits
	mov [__r0],[_Ep]
	mov [__r1],[_Ep+1]
	mov [__r2],[_Ep+2]
	mov [__r3],[_Ep+3]
	mov A,8
X9:
	asl [__r3]
	rlc [__r2]
	rlc [__r1]
	rlc [__r0]
	dec A
	jnz X9
	mov [_Ep],[__r0]
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 116
; 	// 2e octet
; 	Ep+=(unsigned long)Es[2];				// Acquisition des 8 bits suivants
	mov [__r3],[_Es+2]
	mov [__r2],0
	mov [__r1],0
	mov [__r0],0
	mov A,[_Ep+3]
	add A,[__r3]
	mov [__r3],A
	mov A,[_Ep+2]
	adc A,[__r2]
	mov [__r2],A
	mov A,[_Ep+1]
	adc A,[__r1]
	mov [__r1],A
	mov A,[_Ep]
	adc A,[__r0]
	mov [_Ep],A
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 117
; 	Ep=Ep<<8;								// Decalage a gauche de 8 bits
	mov [__r0],[_Ep]
	mov [__r1],[_Ep+1]
	mov [__r2],[_Ep+2]
	mov [__r3],[_Ep+3]
	mov A,8
X10:
	asl [__r3]
	rlc [__r2]
	rlc [__r1]
	rlc [__r0]
	dec A
	jnz X10
	mov [_Ep],[__r0]
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 119
; 	// LSB
; 	Ep+=(unsigned long)Es[3];				// Acquisition des 8 derniers bits memoriss
	mov [__r3],[_Es+3]
	mov [__r2],0
	mov [__r1],0
	mov [__r0],0
	mov A,[_Ep+3]
	add A,[__r3]
	mov [__r3],A
	mov A,[_Ep+2]
	adc A,[__r2]
	mov [__r2],A
	mov A,[_Ep+1]
	adc A,[__r1]
	mov [__r1],A
	mov A,[_Ep]
	adc A,[__r0]
	mov [_Ep],A
	mov [_Ep+1],[__r1]
	mov [_Ep+2],[__r2]
	mov [_Ep+3],[__r3]
	.dbline 120
; 	E=Ep;									// Stockage de la valeur lue dans E
	mov [_E],[_Ep]
	mov [_E+1],[_Ep+1]
	mov [_E+2],[_Ep+2]
	mov [_E+3],[_Ep+3]
	.dbline -2
	.dbline 121
; }
L14:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e EraseE _EraseE fV
_EraseE::
	.dbline -1
	.dbline 128
; 
; 
; /********************************/
; /* Fonction de rinitialisation */
; /********************************/
; // Fonction permettant de rinitialiser la valeur de E
; void EraseE(){
	.dbline 129
; 	if((PRT1DR & 0x04)==0){
	tst REG[4],4
	jnz L19
	.dbline 129
	.dbline 130
; 		E=Eref;
	mov [_E],[_Eref]
	mov [_E+1],[_Eref+1]
	mov [_E+2],[_Eref+2]
	mov [_E+3],[_Eref+3]
	.dbline 131
; 		PRT1DR |= 0x04;
	or REG[4],4
	.dbline 132
; 		saveE();
	xcall _saveE
	.dbline 133
; 	}
L19:
	.dbline 136
	tst REG[4],16
	jnz L21
	.dbline 136
	.dbline 137
	mov [__r0],[_Eref]
	mov [__r1],[_Eref+1]
	mov [__r2],[_Eref+2]
	mov [__r3],[_Eref+3]
	asl [__r3]
	rlc [__r2]
	rlc [__r1]
	rlc [__r0]
	mov [_E],[__r0]
	mov [_E+1],[__r1]
	mov [_E+2],[__r2]
	mov [_E+3],[__r3]
	.dbline 138
	or REG[4],16
	.dbline 139
	and REG[4],-2
	.dbline 139
	and REG[4],-3
	.dbline 140
	xcall _saveE
	.dbline 141
L21:
	.dbline -2
	.dbline 142
; 
; // Fonction supplmentaire pour les tests, qui rinitialise E  2*Eref
; 	if((PRT1DR & 0x10)==0){
; 		E=2*Eref;
; 		PRT1DR |= 0x10;
; 		PRT1DR &= ~0x01; PRT1DR &= ~0x02;
; 		saveE();
; 	}
; }
L18:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init _Init fV
_Init::
	.dbline -1
	.dbline 148
; 
; 
; /*****************************************/
; /* Fonction d'initialisation des modules */
; /*****************************************/
; void Init(){
	.dbline 150
; 	// Initialisation PSoC
;     M8C_EnableGInt;
		or  F, 01h

	.dbline 154
;     
;     
;     // Dmarrage des CAN et CNA
;     ADCINC12_I_Start(ADCINC12_I_HIGHPOWER);
	push X
	mov A,3
	xcall _ADCINC12_I_Start
	.dbline 155
;     ADCINC12_U_Start(ADCINC12_U_HIGHPOWER);
	mov A,3
	xcall _ADCINC12_U_Start
	.dbline 156
;     DAC8_REF_Start(DAC8_REF_HIGHPOWER);  
	mov A,3
	xcall _DAC8_REF_Start
	.dbline 160
;     
;     
;     // Dmarrage des blocs analogiques
;     PGA_U_Start(ADCINC12_I_HIGHPOWER);  
	mov A,3
	xcall _PGA_U_Start
	.dbline 161
;     INSAMP_1_Start(ADCINC12_I_HIGHPOWER);
	mov A,3
	xcall _INSAMP_1_Start
	.dbline 165
;     
;     
;     // EEPROM - Rcupration de la valeur de E prcdemment stocke
;     E2PROM_E_Start();
	xcall _E2PROM_E_Start
	pop X
	.dbline 166
;     readE();
	xcall _readE
	.dbline 174
;     
;     
;     // Connexion des ports numriques
; 	    // Port 1 - Bit 0 --> Signal rechargement
;     	// Port 1 - Bit 1 --> Signal batterie dcharge
;     	// Port 1 - Bit 2 --< Signal de rinitialisation
;     	// Port 1 - Bit 3 --> Signal allum/teint
;     PRT1DR &= ~0x0B;  		// mise  zro des bits utiliss du port 1
	and REG[4],-12
	.dbline 175
;     PRT1DR |= 0x04;			// mise  un du bit 2 du port 1
	or REG[4],4
	.dbline 176
;     PRT1DR |= 0x10;			// mise  un du bit 4 du port 1
	or REG[4],16
	xjmp L25
L24:
	.dbline 180
	.dbline 180
	add [_cpt+3],1
	adc [_cpt+2],0
	adc [_cpt+1],0
	adc [_cpt],0
	.dbline 180
L25:
	.dbline 180
;     
;         
; 	// Tempo d'initialisation pour la mise sous tension
; 	while(cpt<300000){cpt++;}
	mov A,[_cpt]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_cpt+3]
	sub A,-32
	or [__rX],A
	mov A,[_cpt+2]
	sbb A,-109
	or [__rX],A
	mov A,[_cpt+1]
	sbb A,4
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L24
X11:
	.dbline 181
; 	PRT1DR |= 0x08;								// Calculateur prt
	or REG[4],8
	.dbline 184
; 	
; 	// Rcupration de U et I (au dmarrage)
; 	Acquis();
	xcall _Acquis
	.dbline -2
	.dbline 185
; }
L23:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Decharge _Decharge fV
_Decharge::
	.dbline -1
	.dbline 195
; 
; 
; /**********************/
; /* Boucle de Decharge */
; /**********************/
; // Si I est ngatif, alors on rentre dans cette boucle de Decharge.
; // I tant ngatif, le rsultat E l'est aussi. Le compteur d'nergie E dcrmente.
; // S'il atteind une valeur limite Eref, on envoie alors le signal de rechargement au robot.
; 
; void Decharge() {
	.dbline 196
; 	EraseE();
	xcall _EraseE
	.dbline 198
; 
; 		if((E>Eref)&&(U>Uref))PRT1DR &= ~0x01;		// Mise  1 du bit 0 du port 1 - Pas besoin de recharger
	mov A,[_E]
	xor A,-128
	mov [__rY],A
	mov A,[_Eref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_E+3]
	sub A,[_Eref+3]
	or [__rX],A
	mov A,[_E+2]
	sbb A,[_Eref+2]
	or [__rX],A
	mov A,[_E+1]
	sbb A,[_Eref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L28
	mov A,[__rX]
	jz L28
X12:
	mov A,[_U]
	xor A,-128
	mov [__rY],A
	mov A,[_Uref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_U+3]
	sub A,[_Uref+3]
	or [__rX],A
	mov A,[_U+2]
	sbb A,[_Uref+2]
	or [__rX],A
	mov A,[_U+1]
	sbb A,[_Uref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L28
	mov A,[__rX]
	jz L28
X13:
	.dbline 198
	and REG[4],-2
L28:
	.dbline 199
; 		Acquis();									// Acquisition de U et I  une frquence de 300 Hz		
	xcall _Acquis
	.dbline 201
; 						
; 		if(U>Uref){									// Test si U est suprieure  une tension de rfrence
	mov A,[_U]
	xor A,-128
	mov [__rY],A
	mov A,[_Uref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_U+3]
	sub A,[_Uref+3]
	or [__rX],A
	mov A,[_U+2]
	sbb A,[_Uref+2]
	or [__rX],A
	mov A,[_U+1]
	sbb A,[_Uref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L30
	mov A,[__rX]
	jz L30
X14:
	.dbline 201
	.dbline 202
; 			En=U*I/(k*f);							// si c'est le cas, calcul de P
	mov A,[_I]
	push A
	mov A,[_I+1]
	push A
	mov A,[_I+2]
	push A
	mov A,[_I+3]
	push A
	mov A,[_U]
	push A
	mov A,[_U+1]
	push A
	mov A,[_U+2]
	push A
	mov A,[_U+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[_f]
	push A
	mov A,[_f+1]
	push A
	mov A,[_f+2]
	push A
	mov A,[_f+3]
	push A
	mov A,[_k]
	push A
	mov A,[_k+1]
	push A
	mov A,[_k+2]
	push A
	mov A,[_k+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [_En+3],A
	pop A
	mov [_En+2],A
	pop A
	mov [_En+1],A
	pop A
	mov [_En],A
	add SP,-4
	.dbline 203
; 			if(E>En){E+=En;}				
	mov A,[_E]
	xor A,-128
	mov [__rY],A
	mov A,[_En]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_E+3]
	sub A,[_En+3]
	or [__rX],A
	mov A,[_E+2]
	sbb A,[_En+2]
	or [__rX],A
	mov A,[_E+1]
	sbb A,[_En+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L32
	mov A,[__rX]
	jz L32
X15:
	.dbline 203
	.dbline 203
	mov A,[_En+3]
	add [_E+3],A
	mov A,[_En+2]
	adc [_E+2],A
	mov A,[_En+1]
	adc [_E+1],A
	mov A,[_En]
	adc [_E],A
	.dbline 203
	xjmp L33
L32:
	.dbline 204
; 			else {PRT1DR |= 0x02; E=0;}				// Erreur batterie dcharge
	.dbline 204
	or REG[4],2
	.dbline 204
	mov [_E],0
	mov [_E+1],0
	mov [_E+2],0
	mov [_E+3],0
	.dbline 204
L33:
	.dbline 205
; 			saveE();
	xcall _saveE
	.dbline 207
; 			
; 		}  	 	
	xjmp L31
L30:
	.dbline 209
; 									
; 		else{										// sinon
	.dbline 210
	mov [_cpt],0
	mov [_cpt+1],0
	mov [_cpt+2],0
	mov [_cpt+3],0
L34:
	.dbline 210
; 			for(cpt=0;cpt<300;cpt++){				// Attente d'une seconde pour retester U
	.dbline 213
; 													// permet de savoir si une chute de tension est momentane
; 													// (due  un appel de courant) ou si la batterie est dechargee
; 				Acquis();
	xcall _Acquis
	.dbline 214
; 				En=U*I/(k*f);
	mov A,[_I]
	push A
	mov A,[_I+1]
	push A
	mov A,[_I+2]
	push A
	mov A,[_I+3]
	push A
	mov A,[_U]
	push A
	mov A,[_U+1]
	push A
	mov A,[_U+2]
	push A
	mov A,[_U+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[_f]
	push A
	mov A,[_f+1]
	push A
	mov A,[_f+2]
	push A
	mov A,[_f+3]
	push A
	mov A,[_k]
	push A
	mov A,[_k+1]
	push A
	mov A,[_k+2]
	push A
	mov A,[_k+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [_En+3],A
	pop A
	mov [_En+2],A
	pop A
	mov [_En+1],A
	pop A
	mov [_En],A
	add SP,-4
	.dbline 215
; 				if(E>En)E+=En;
	mov A,[_E]
	xor A,-128
	mov [__rY],A
	mov A,[_En]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_E+3]
	sub A,[_En+3]
	or [__rX],A
	mov A,[_E+2]
	sbb A,[_En+2]
	or [__rX],A
	mov A,[_E+1]
	sbb A,[_En+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L38
	mov A,[__rX]
	jz L38
X16:
	.dbline 215
	mov A,[_En+3]
	add [_E+3],A
	mov A,[_En+2]
	adc [_E+2],A
	mov A,[_En+1]
	adc [_E+1],A
	mov A,[_En]
	adc [_E],A
	xjmp L39
L38:
	.dbline 216
; 				else {PRT1DR |= 0x02; E=0;}			// Erreur batterie dcharge
	.dbline 216
	or REG[4],2
	.dbline 216
	mov [_E],0
	mov [_E+1],0
	mov [_E+2],0
	mov [_E+3],0
	.dbline 216
L39:
	.dbline 217
; 				saveE();
	xcall _saveE
	.dbline 218
; 				if(E<Eref){							// Test sur l'nergie
	mov A,[_E]
	xor A,-128
	mov [__rY],A
	mov A,[_Eref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_E+3]
	sub A,[_Eref+3]
	or [__rX],A
	mov A,[_E+2]
	sbb A,[_Eref+2]
	or [__rX],A
	mov A,[_E+1]
	sbb A,[_Eref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jnc L40
	mov A,[__rX]
	jz L40
X17:
	.dbline 218
	.dbline 219
; 					PRT1DR |= 0x01;					// On envoie l'ordre au robot d'aller se recharger
	or REG[4],1
	.dbline 220
; 				}
L40:
	.dbline 221
L35:
	.dbline 210
	add [_cpt+3],1
	adc [_cpt+2],0
	adc [_cpt+1],0
	adc [_cpt],0
	.dbline 210
	mov A,[_cpt]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_cpt+3]
	sub A,44
	or [__rX],A
	mov A,[_cpt+2]
	sbb A,1
	or [__rX],A
	mov A,[_cpt+1]
	sbb A,0
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L34
X18:
	.dbline 222
; 			}
; 			if(U<Uref){								// Test sur U
	mov A,[_U]
	xor A,-128
	mov [__rY],A
	mov A,[_Uref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_U+3]
	sub A,[_Uref+3]
	or [__rX],A
	mov A,[_U+2]
	sbb A,[_Uref+2]
	or [__rX],A
	mov A,[_U+1]
	sbb A,[_Uref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jnc L42
	mov A,[__rX]
	jz L42
X19:
	.dbline 222
	.dbline 223
; 				PRT1DR |= 0x01;						// On envoie l'ordre au robot d'aller se recharger
	or REG[4],1
	.dbline 224
;     		}
L42:
	.dbline 225
;     		if(U<Ubas){	
	mov A,[_U]
	xor A,-128
	mov [__rY],A
	mov A,[_Ubas]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_U+3]
	sub A,[_Ubas+3]
	or [__rX],A
	mov A,[_U+2]
	sbb A,[_Ubas+2]
	or [__rX],A
	mov A,[_U+1]
	sbb A,[_Ubas+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jnc L44
	mov A,[__rX]
	jz L44
X20:
	.dbline 225
	.dbline 226
;     			PRT1DR |= 0x02;						// Erreur batterie dcharge : ordre d'arret d'urgence
	or REG[4],2
	.dbline 227
;     		}
L44:
	.dbline 228
; 		} 
L31:
	.dbline 230
	mov A,[_E]
	xor A,-128
	mov [__rY],A
	mov A,[_Eref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_E+3]
	sub A,[_Eref+3]
	or [__rX],A
	mov A,[_E+2]
	sbb A,[_Eref+2]
	or [__rX],A
	mov A,[_E+1]
	sbb A,[_Eref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jnc L46
	mov A,[__rX]
	jz L46
X21:
	.dbline 230
	.dbline 231
	or REG[4],1
	.dbline 232
L46:
	.dbline -2
	.dbline 234
; 					 				
; 		if(E<Eref){									// Test sur l'nergie	
; 			PRT1DR |= 0x01;							// On envoie l'ordre au robot d'aller se recharger
; 		}
; 	
; }
L27:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Charge _Charge fV
_Charge::
	.dbline -1
	.dbline 244
; 
; 
; 
; /********************/
; /* Boucle de Charge */
; /********************/
; // Si I est positif, alors on rentre dans cette boucle de Charge.
; // I tant positif, le rsultat E l'est aussi. Le compteur d'nergie E s'incrmente.
; 
; void Charge() {
	.dbline 246
; 
; 	EraseE();
	xcall _EraseE
	.dbline 247
; 	if(E>Eref) { PRT1DR &= ~0x01; PRT1DR &= ~0x02;}		// Mise  1 du bit 0 du port 1
	mov A,[_E]
	xor A,-128
	mov [__rY],A
	mov A,[_Eref]
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_E+3]
	sub A,[_Eref+3]
	or [__rX],A
	mov A,[_E+2]
	sbb A,[_Eref+2]
	or [__rX],A
	mov A,[_E+1]
	sbb A,[_Eref+1]
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L49
	mov A,[__rX]
	jz L49
X22:
	.dbline 247
	.dbline 247
	and REG[4],-2
	.dbline 247
	and REG[4],-3
	.dbline 247
L49:
	.dbline 249
; 			
; 	Acquis();											// Acquisition de U et I  une frquence de 300 Hz
	xcall _Acquis
	.dbline 251
; 
; 	En=U*I/(k*f);										// Calcul de E
	mov A,[_I]
	push A
	mov A,[_I+1]
	push A
	mov A,[_I+2]
	push A
	mov A,[_I+3]
	push A
	mov A,[_U]
	push A
	mov A,[_U+1]
	push A
	mov A,[_U+2]
	push A
	mov A,[_U+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	mov A,[_f]
	push A
	mov A,[_f+1]
	push A
	mov A,[_f+2]
	push A
	mov A,[_f+3]
	push A
	mov A,[_k]
	push A
	mov A,[_k+1]
	push A
	mov A,[_k+2]
	push A
	mov A,[_k+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [_En+3],A
	pop A
	mov [_En+2],A
	pop A
	mov [_En+1],A
	pop A
	mov [_En],A
	add SP,-4
	.dbline 252
; 	E+=En;
	mov A,[_En+3]
	add [_E+3],A
	mov A,[_En+2]
	adc [_E+2],A
	mov A,[_En+1]
	adc [_E+1],A
	mov A,[_En]
	adc [_E],A
	.dbline 254
; 	
; 	saveE();											// Memorisation de la valeur de l'energie
	xcall _saveE
	.dbline -2
	.dbline 255
; }
L48:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 266
; 
; 
; 
; 
; /***********************/
; /*					   */
; /* Programme principal */
; /*					   */
; /***********************/
; void main()
; {	
	.dbline 267
; 	Init();						// Initialisation
	xcall _Init
	xjmp L53
X23:
	.dbline 268
; 	while(1){					// Gestion de l'utilisation et de la charge
L55:
	.dbline 269
	xcall _Decharge
L56:
	.dbline 269
; 		while(I<=0) Decharge();	
	mov A,[_I]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_I+3]
	sub A,0
	or [__rX],A
	mov A,[_I+2]
	sbb A,0
	or [__rX],A
	mov A,[_I+1]
	sbb A,0
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jc L55
	mov A,[__rX]
	jz L55
X25:
	xjmp L59
L58:
	.dbline 270
	xcall _Charge
L59:
	.dbline 270
	mov A,[_I]
	xor A,-128
	mov [__rY],A
	mov A,0
	xor A,-128
	mov [__rZ],A
	mov [__rX],0
	mov A,[_I+3]
	sub A,0
	or [__rX],A
	mov A,[_I+2]
	sbb A,0
	or [__rX],A
	mov A,[_I+1]
	sbb A,0
	or [__rX],A
	mov A,[__rY]
	sbb A,[__rZ]
	or [__rX],A
	jz X26
	jnc L58
X26:
	.dbline 272
L53:
	.dbline 268
	xjmp L56
X24:
	.dbline -2
	.dbline 274
; 		while(I>0) Charge();
; 		
; 	}
; 
; }
L51:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./main.c
_Es::
	.blkb 4
	.dbsym e Es _Es A[4:4]c
_En::
	.blkb 4
	.dbsym e En _En L
_Ep::
	.blkb 4
	.dbsym e Ep _Ep L
_E::
	.blkb 4
	.dbsym e E _E L
_Ucalc::
	.blkb 4
	.dbsym e Ucalc _Ucalc L
_I::
	.blkb 4
	.dbsym e I _I L
_U::
	.blkb 4
	.dbsym e U _U L
